; AutoLISP-Programm zum Zeichnen einer Klothoide
; Autor: Jrgen Palme
; Version 1.1, (Shareware-Version), September 1994
; Voraussetzung: AutoCAD fr DOS ab Version 12.0, deutsch
; zugehrige Datei: KLOTHO11.DCL

;-----------------------------------
;Initialisierung von Ausgangswerten
;-----------------------------------
(defun init ()
  (setq flag_z nil)
  (if (= nil er_) (setq er_ ""))
  (if (= nil ep_) (setq ep_ ""))
  (if (= nil el_) (setq el_ ""))
  (if (= nil ew_) (setq ew_ ""))
  
  (set_tile "_er" er_)
  (set_tile "_ep" ep_)
  (set_tile "_el" el_)
  (set_tile "_ew" ew_)

  (if (/= ew_ "") (mode_tile "_ew" 2))
  (if (/= el_ "") (mode_tile "_el" 2))
  (if (/= ep_ "") (mode_tile "_ep" 2))
  (if (/= er_ "") (mode_tile "_er" 2))
  
  (if (/= nil r_) (set_tile "_br" r_) (set_tile "_br" "   ???"))
  (if (/= nil p_) (set_tile "_bp" p_) (set_tile "_bp" "   ???"))
  (if (/= nil l_) (set_tile "_bl" l_) (set_tile "_bl" "   ???"))
  (if (/= nil w_) (set_tile "_bw" w_) (set_tile "_bw" "   ???"))
  
  (if (= nil _exp) (setq _exp "0.00"))
  (setq exp_ _exp)
  (if (= nil _eyp) (setq _eyp "0.00"))
  (setq eyp_ _eyp)
  (if (= nil _ewp) (setq _ewp "0.00"))
  (setq ewp_ _ewp)
  (set_tile "_exp" (rtos (atof _exp)))
  (set_tile "_eyp" (rtos (atof _eyp)))
  (set_tile "_ewp" (rtos (atof _ewp)))
  
  (if (= nil _anz) (setq _anz 100))
  (setq anz_ _anz) (setq anz__ _anz)
  (if (= nil _glatt) (setq _glatt "0"))
  (setq glatt_ _glatt) (setq glatt__ _glatt)
  (if (= nil _we)(setq _we "ag"))
  (setq we_ _we)(setq we__ _we)
  (if (= _we "ag")
    (progn  
      (setq wfkt1 90.0
            wfkt2 180.0
            ogw 1833.5
      )
      (set_tile "w_anz1" "[]")
      (set_tile "w_anz2" "[]")
    )
    (progn
      (setq wfkt1 100.0
            wfkt2 200.0
            ogw 2037.2
      )
      (set_tile "w_anz1" "[gon]")
      (set_tile "w_anz2" "[gon]")
    )
  )
)


;------------------
;Radius eingegeben
;------------------
(defun radius ()
  (setq merker 1)
  (set_tile "error" "")
  (if (or
       (and (= "" ep_)(= "" el_)) 
       (and (= "" ep_)(= "" ew_))
       (and (= "" el_)(= "" ew_))
      )
    (progn
      (setq er_ $value) 
      (berech)
    )
  )
)


;---------------------
;Parameter eingegeben
;---------------------
(defun param ()
  (setq merker 2)
  (set_tile "error" "")
  (if (or
       (and (= "" er_)(= "" el_)) 
       (and (= "" er_)(= "" ew_))
       (and (= "" el_)(= "" ew_))
      )
    (progn
      (setq ep_ $value) 
      (berech)
    )
  )
)


;---------------------
;Lnge eingegeben
;---------------------
(defun laenge ()
  (setq merker 3)
  (set_tile "error" "")  
  (if (or
       (and (= "" er_)(= "" ep_)) 
       (and (= "" er_)(= "" ew_))
       (and (= "" ep_)(= "" ew_))
      )
    (progn
      (setq el_ $value) 
      (berech)
    )
  )
)


;---------------------
;End-Winkel eingegeben
;---------------------
(defun winkel ()
  (set_tile "error" "")  
  (if (or
       (and (= "" er_)(= "" ep_)) 
       (and (= "" er_)(= "" el_))
       (and (= "" ep_)(= "" el_))
      )
    (progn
      (setq ew_ $value) 
      (berech)
    )
  )
)


;---------------------
; alle Werte anzeigen        (sobald zwei Werte eingegeben wurden)
;---------------------
(defun berech ()
  (if (or
        (and (= "" er_) (= "" ep_) (= "" el_))
        (and (= "" er_) (= "" ep_) (= "" ew_))
        (and (= "" er_) (= "" el_) (= "" ew_))
        (and (= "" ep_) (= "" el_) (= "" ew_))
      )
; dann:                              ;solange nur ein oder kein
    (progn                           ;Wert eingetragen ist
      (mode_tile "_er" 0)
      (mode_tile "_ep" 0)
      (mode_tile "_el" 0)
      (mode_tile "_ew" 0)
      (mode_tile "w_anz1" 0)
      (mode_tile "_br" 1)
      (mode_tile "_bp" 1)
      (mode_tile "_bl" 1)
      (mode_tile "_bw" 1)
    )
; sonst:
    (progn
      (if (and (/= "" er_)(/= "" ep_))
        (progn
          (mode_tile "_el" 1)
          (mode_tile "_ew" 1)
          (mode_tile "w_anz1" 1)
          (set_tile "_el" "")
          (set_tile "_ew" "")
          (if (and (> (atof er_) 0)(> (atof ep_) 0))
            (ber1)
            (progn
              (if (<= (atof er_) 0)
                (progn
                  (alert "Radius R mu grer Null sein")
                  (mode_tile "_er" 2)
                )
                (progn
                  (alert "Parameter P mu grer Null sein")
                  (mode_tile "_ep" 2)
                )
              )
            )
          )
        )
      )
      (if (and (/= "" er_)(/= "" el_))
        (progn
          (mode_tile "_ep" 1)
          (mode_tile "_ew" 1)
          (mode_tile "w_anz1" 1)
          (set_tile "_ep" "")
          (set_tile "_ew" "")
          (if (and (> (atof er_) 0)(> (atof el_) 0))
            (ber2)
            (progn
              (if (<= (atof er_) 0)
                (progn
                  (alert "Radius R mu grer Null sein")
                  (mode_tile "_er" 2)
                )
                (progn
                  (alert "Lnge L mu grer Null sein")
                  (mode_tile "_el" 2)
                )
              )
            )
          )
        )
      )
      (if (and (/= "" er_)(/= "" ew_))
        (progn
          (mode_tile "_ep" 1)
          (mode_tile "_el" 1)
          (set_tile "_ep" "")
          (set_tile "_el" "")
          (if (and (> (atof er_) 0)(> (atof ew_) 0))
            (ber3)
            (progn
              (if (<= (atof er_) 0)
                (progn
                  (alert "Radius R mu grer Null sein")
                  (mode_tile "_er" 2)
                )
                (progn
                  (alert "Winkel W mu grer Null sein")
                  (mode_tile "_ew" 2)
                )
              )
            )
          )
        )
      )
      (if (and (/= "" ep_)(/= "" el_))
        (progn
          (mode_tile "_er" 1)
          (mode_tile "_ew" 1)
          (mode_tile "w_anz1" 1)
          (set_tile "_er" "")
          (set_tile "_ew" "")
          (if (and (> (atof ep_) 0)(> (atof el_) 0))
            (ber4)
            (progn
              (if (<= (atof ep_) 0)
                (progn
                  (alert "Parameter P mu grer Null sein")
                  (mode_tile "_ep" 2)
                )
                (progn
                  (alert "Lnge L mu grer Null sein")
                  (mode_tile "_el" 2)
                )
              )
            )
          )
        )
      )
      (if (and (/= "" ep_)(/= "" ew_))
        (progn
          (mode_tile "_er" 1)
          (mode_tile "_el" 1)
          (set_tile "_er" "")
          (set_tile "_el" "")
          (if (and (> (atof ep_) 0)(> (atof ew_) 0))
            (ber5)
            (progn
              (if (<= (atof ep_) 0)
                (progn
                  (alert "Parameter P mu grer Null sein")
                  (mode_tile "_ep" 2)
                )
                (progn
                  (alert "Winkel W mu grer Null sein")
                  (mode_tile "_ew" 2)
                )
              )
            )
          )
        )
      )
      (if (and (/= "" el_)(/= "" ew_))
        (progn
          (mode_tile "_er" 1)
          (mode_tile "_ep" 1)
          (set_tile "_er" "")
          (set_tile "_ep" "")
          (if (and (> (atof el_) 0)(> (atof ew_) 0))
            (ber6)
            (progn
              (if (<= (atof el_) 0)
                (progn
                  (alert "Lnge L mu grer Null sein")
                  (mode_tile "_el" 2)
                )
                (progn
                  (alert "Winkel W mu grer Null sein")
                  (mode_tile "_ew" 2)
                )
              )
            )
          )
        )
      )
    )
  )
)


;------------------------------
;Berechnung der Geometriewerte
;------------------------------

(defun ber1 ()
  (setq flag_z t)
  (setq r (atof er_))
  (setq r_ (rtos r))
  (set_tile "_br" r_)
  (mode_tile "_br" 0)

  (setq p (atof ep_))
  (setq p_ (rtos p))
  (set_tile "_bp" p_)
  (mode_tile "_bp" 0)

  (setq l (/ (* p p) (float r)))
  (setq l_ (rtos l))
  (set_tile "_bl" l_)
  (mode_tile "_bl" 0)

  (setq li (/ l p))

  (setq w (/ (* li li wfkt1) pi))
  (setq w_ (rtos w))
  (set_tile "_bw" w_)
  (mode_tile "_bw" 0)
  (if (> w ogw)
    (progn
      (setq flag_z nil)
      (if (= merker 1)
        (progn
          (set_tile "error" "Sie sollten die Bedingung  \"R >= P/8\" einhalten")
          (mode_tile "_er" 2)
          (set_tile "_er" "")
        )
      )
      (if (= merker 2)
        (progn
          (set_tile "error" "Sie sollten die Bedingung  \"P <= 8*R\" einhalten")
          (mode_tile "_ep" 2)
          (set_tile "_ep" "")
        )
      )
    )
  )
)

(defun ber2 ()
  (setq flag_z t)
  (setq r (atof er_))
  (setq r_ (rtos r))
  (set_tile "_br" r_)
  (mode_tile "_br" 0)
  
  (setq l (atof el_))
  (setq l_ (rtos l))
  (set_tile "_bl" l_)
  (mode_tile "_bl" 0)

  (setq p (sqrt(* r l)))
  (setq p_ (rtos p))
  (set_tile "_bp" p_)
  (mode_tile "_bp" 0)

  (setq li (/ l p))

  (setq w (/ (* li li wfkt1) pi))
  (setq w_ (rtos w))
  (set_tile "_bw" w_)
  (mode_tile "_bw" 0)
  (if (> w ogw)
    (progn
      (setq flag_z nil)
      (if (= merker 1)
        (progn
          (set_tile "error" "Sie sollten die Bedingung  \"R >= L/64\" einhalten")
          (mode_tile "_er" 2)
          (set_tile "_er" "")
        )
      )
      (if (= merker 3)
        (progn
          (set_tile "error" "Sie sollten die Bedingung  \"L <= 64*R\" einhalten")
          (mode_tile "_el" 2)
          (set_tile "_el" "")
        )
      )
    )
  )
)

(defun ber3 ()
  (setq flag_z t)
  (setq r (atof er_))
  (setq r_ (rtos r))
  (set_tile "_br" r_)
  (mode_tile "_br" 0)
  
  (setq w (atof ew_))
  (setq w_ (rtos w))
  (set_tile "_bw" w_)
  (mode_tile "_bw" 0)

  (setq li (sqrt(/(* w pi) wfkt1)))

  (setq l (* r li li))
  (setq l_ (rtos l))
  (set_tile "_bl" l_)
  (mode_tile "_bl" 0)

  (setq p (* li r))
  (setq p_ (rtos p))
  (set_tile "_bp" p_)
  (mode_tile "_bp" 0)
  (if (> w ogw)
    (progn
      (setq flag_z nil)
      (if (= we_ "ag") 
        (set_tile "error" "Sie sollten die Bedingung  \"W <= 1800\" einhalten")
        (set_tile "error" "Sie sollten die Bedingung  \"W <= 2035 gon\" einhalten")
      )
      (progn
        (mode_tile "_ew" 2)
        (set_tile "_ew" "")
      )
    )
  )
)

(defun ber4 ()
  (setq flag_z t)
  (setq p (atof ep_))
  (setq p_ (rtos p))
  (set_tile "_bp" p_)
  (mode_tile "_bp" 0)

  (setq l (atof el_))
  (setq l_ (rtos l))
  (set_tile "_bl" l_)
  (mode_tile "_bl" 0)

  (setq r (/ (* p p) (float l)))
  (setq r_ (rtos r))
  (set_tile "_br" r_)
  (mode_tile "_br" 0)

  (setq li (/ l p))

  (setq w (/ (* li li wfkt1) pi))
  (setq w_ (rtos w))
  (set_tile "_bw" w_)
  (mode_tile "_bw" 0)
  (if (> w ogw)
    (progn
      (setq flag_z nil)
      (if (= merker 2)
        (progn
          (set_tile "error" "Sie sollten die Bedingung  \"P >= L/8\" einhalten")
          (mode_tile "_ep" 2)
          (set_tile "_ep" "")
        )
      )
      (if (= merker 3)
        (progn
          (set_tile "error" "Sie sollten die Bedingung  \"L <= 8*P\" einhalten")
          (mode_tile "_el" 2)
          (set_tile "_el" "")
        )
      )
    )
  )
)

(defun ber5 ()
  (setq flag_z t)
  (setq p (atof ep_))
  (setq p_ (rtos p))
  (set_tile "_bp" p_)
  (mode_tile "_bp" 0)
  
  (setq w (atof ew_))
  (setq w_ (rtos w))
  (set_tile "_bw" w_)
  (mode_tile "_bw" 0)
  
  (setq li (sqrt(/(* w pi) wfkt1)))

  (setq l (* p li))
  (setq l_ (rtos l))
  (set_tile "_bl" l_)
  (mode_tile "_bl" 0)
  
  (setq r (/ (* p p) l))
  (setq r_ (rtos r))
  (set_tile "_br" r_)
  (mode_tile "_br" 0)
  (if (> w ogw)
    (progn
      (setq flag_z nil)
      (if (= we_ "ag")
        (set_tile "error" "Sie sollten die Bedingung  \"W <= 1800\" einhalten")
        (set_tile "error" "Sie sollten die Bedingung  \"W <= 2035 gon\" einhalten")
      )
      (progn
        (mode_tile "_ew" 2)
        (set_tile "_ew" "")
      )
    )
  )
)

(defun ber6 ()
  (setq flag_z t)
  (setq l (atof el_))
  (setq l_ (rtos l))
  (set_tile "_bl" l_)
  (mode_tile "_bl" 0)

  (setq w (atof ew_))
  (setq w_ (rtos w))
  (set_tile "_bw" w_)
  (mode_tile "_bw" 0)
  
  (setq li (sqrt(/(* w pi) wfkt1)))

  (setq p (/ l li))
  (setq p_ (rtos p))
  (set_tile "_bp" p_)
  (mode_tile "_bp" 0)

  (setq r (/ p li))
  (setq r_ (rtos r))
  (set_tile "_br" r_)
  (mode_tile "_br" 0)
  (if (> w ogw)
    (progn
      (setq flag_z nil)
      (if (= we_ "ag")
        (set_tile "error" "Sie sollten die Bedingung  \"W <= 1800\" einhalten")
        (set_tile "error" "Sie sollten die Bedingung  \"W <= 2035 gon\" einhalten")
      )
      (progn
        (mode_tile "_ew" 2)
        (set_tile "_ew" "")
      )
    )
  )
)


;-----------------------------
; Optionen-Fenster ffnen
;-----------------------------
(defun genau ()
  (if (not (new_dialog "genau" nr))
    (exit)
  )
  (set_tile "anz" (itoa anz_))
  (set_tile "glatt" glatt_)
  (set_tile "wi_einh" we_)
  (action_tile "accept" "(do_it1)(done_dialog)(ausw4)")
  (action_tile "glatt" "(setq glatt__ $value)")
  (action_tile "anz" "(ausw2 $value)")
  (action_tile "wi_einh" "(ausw3 $value)")
  (start_dialog)
)

(defun ausw2 (wert)
  (setq anz__ (atoi wert))
  (if (< anz__ 5)(setq anz__ 5))
  (set_tile "anz" (itoa anz__))
)

(defun ausw3 (wert)
  (if (= wert "ng")
    (setq we__ "ng")
    (setq we__ "ag")
  )
)

(defun ausw4 ()
  (if (/= ew_ "") (mode_tile "_ew" 2))
  (if (/= el_ "") (mode_tile "_el" 2))
  (if (/= ep_ "") (mode_tile "_ep" 2))
  (if (/= er_ "") (mode_tile "_er" 2))
  (if (= we_ "ag") 
    (progn
      (set_tile "w_anz1" "[]")
      (set_tile "w_anz2" "[]")
    )
    (progn
      (set_tile "w_anz1" "[gon]")
      (set_tile "w_anz2" "[gon]")
    )
  )
)

(defun do_it1 ()
  (if (/= anz__ nil) (setq anz_ anz__))
  (if (/= glatt__ nil) (setq glatt_ glatt__))
  (if (/= we__ nil)(setq we_ we__))
  (if (= we_ "ag")
    (setq wfkt1 90.0
          wfkt2 180.0
          ogw 1833.5
    )
    (setq wfkt1 100.0
          wfkt2 200.0
          ogw 2037.2
    )
  )
  (berech)
)


;----------------------------
; Hilfsobjekt-Fenster ffnen
;----------------------------
(defun obj_h ()
  (if (not (new_dialog "obj_hilfe" nr))
    (exit)
  )
  (start_dialog)
)

    
;----------------------
; Info-Fenster ffnen
;----------------------
(defun info ()
  (if (not (new_dialog "info" nr))
    (exit)
  )
  (start_dialog)
)


;-------------------------------------------
;Koordinaten fr Klothoidenpunkte berechnen
;-------------------------------------------
(defun e_klot(lk)
  
  (setq delta 0.5e-10
        i     0
        b     lk
        xe    b
        ye    0
        k     -1
  )
  (while (> (abs b) delta)
     (setq i (+ i 2)
           k (* k -1)
           b (* b lk lk (/ (- i 1.0) i (+ i 1.0)))
     )
     (if (< k 0)
       (setq b  (* b -1)
             xe (+ xe b)
       )
       (setq ye (+ ye b)
       )
     )
  )
  (setq xn (* xe p)         ;noch transformieren in 
        yn (* ye p)         ;neues Koordinatensystem
        xend xn
        yend yn
  )
  (if (or (/= 0 exp)(/= 0 eyp)(/= 0 ewp))
    (progn
      (setq ww (/(* pi ewp)wfkt2))
      (setq x (+ exp (-(* (cos ww)xn)(* (sin ww)yn))))
      (setq y (+ eyp (+(* (sin ww)xn)(* (cos ww)yn))))    
    )
    (progn
      (setq x xn)
      (setq y yn)
    )
  )
)


;-------------------
;Klothoide zeichnen
;-------------------
(defun z_klot ()
  (setvar "cmdecho" 0)
  (setq lf 0)
  (setq dlf (/ li _anz))
  (command "plinie")
  (command (list exp eyp))
  (repeat _anz
    (setq lf (+ lf dlf))
    (e_klot lf) 
    (command (list x y))
  )
  (command "")
  (if (= _glatt "1")
    (command "pedit" "l" "a" "")
  )
  (princ)
)


;----------------------------
; Onlinehilfe-Fenster ffnen
;----------------------------
(defun onl_h ()
  (if (not (new_dialog "onl_hilfe" nr))
    (exit)
  )
  (start_list "online")
  
  
  (add_list "  Das Programm zeichnet auf der Grundlage vorzugebender") 
  (add_list "  geometrischer Gren einen Klothoidenast als Folge")
  (add_list "  beliebig vieler Liniensegmente (Polylinie). Die Klothoide")
  (add_list "  beginnt stets mit einem unendlich groen Krmmungsradius,")
  (add_list "  welcher sich linear mit der Bogenlnge verringert")
  (add_list "  und endet mit dem Radius R. Die Klothoide dreht entgegen")
  (add_list "  dem Uhrzeigersinn. (Entgegengesetzt drehende Klothoiden")
  (add_list "  knnen leicht durch Spiegelung erzeugt werden).")
  (add_list "   ")
  (add_list "  Eingabeblock \"Abmessungen\":")
  (add_list "  ---------------------------")
  (add_list "  Beliebige zwei der vier geometrischen Gren")
  (add_list "    - Radius am Klothoidenendpunkt,")
  (add_list "    - Parameter (Mastabsfaktor),")
  (add_list "    - (Bogen-)Lnge der Kurve und")
  (add_list "    - Tangentenwinkel im Klothoidenendpunkt (bezogen auf")
  (add_list "      Tangentenrichtung im Klothoidenstartpunkt)")
  (add_list "  knnen eingegeben werden.")
  (add_list "  Die beiden anderen werden selbstndig vom Programm berechnet.")
  (add_list "  Die Winkelangabe /-ausgabe erfolgt wahlweise in Altgrad []")
  (add_list "  oder in Neugrad [gon] (vgl. \"Optionen\").")
  (add_list "  Soll eine dritte Gre vorgegeben werden, ist zunchst")
  (add_list "  mindestens einer der bereits eingegebenen Werte zu lschen.")
  (add_list "  Das Lschen mu mittels ENTER (RETURN) besttigt werden.")
  (add_list "   ")
  (add_list "  Eingabeblock \"Lage\":")
  (add_list "  --------------------")
  (add_list "  Startpunkt und Startrichtung der Klothoide knnen frei")
  (add_list "  gewhlt werden. Die Winkelangabe erfolgt wahlweise in")
  (add_list "  Altgrad [] oder Neugrad [gon] (vgl. \"Optionen\").")
  (add_list " ")
  (add_list "  \"Optionen\":")
  (add_list "  -----------")
  (add_list "  \"Segmentanzahl\" bestimmt durch die Anzahl der zu erzeugenden")
  (add_list "  Liniensegmente die Genauigkeit der Darstellung der Klothoide.")
  (add_list "  Je hher die Segmentanzahl gewhlt wird, desto \"glatter\"")
  (add_list "  wird die Kurve (zu Lasten lngerer Rechenzeit). In")
  (add_list "  Abhngigkeit von der Kurvenlnge sind Werte im Bereich von")
  (add_list "  etwa 10 bis 200 sinnvoll. Vom Programm wird ein Mindestwert")
  (add_list "  von 5 Liniensegmenten erzwungen.")
  (add_list " ")
  (add_list "  \"Kurve gltten\" bewirkt, da die vom Programm erzeugte Polylinie")
  (add_list "  automatisch mit PEDIT/kurveAngleichen bearbeitet wird. Es ist")
  (add_list "  jedoch besser, bei einer zu \"eckigen\" Kurve eine hhere Anzahl")
  (add_list "  von Liniensegmenten zu whlen.")
  (add_list "   ")
  (add_list "  \"Altgrad\"/\"Neugrad\" lt eine wahlweise Interpretation der")
  (add_list "  Winkelangaben in Alt- [] oder Neugrad [gon] zu. Vorgegebene")
  (add_list "  Winkelgren (Abmessungen und Lage) behalten stets ihren")
  (add_list "  absoluten Wert und werden wahlweise als Alt- oder Neugrad")
  (add_list "  interpretiert; ein durch Radius, Parameter und/oder Lnge")
  (add_list "  berechneter Endwinkel hingegen wird in der jeweils gewhlten")
  (add_list "  Maeinheit ausgegeben.")
  (add_list " ")
  (add_list "  \"Hilfsobjekte\":   (in Shareware-Version nicht verfgbar)")
  (add_list "  ---------------")
  (add_list "  Zur besseren Handhabung der Klothoide in der Zeichnung")
  (add_list "  (z.B. drehen, schieben, spiegeln) knnen vom Programm wahlweise")
  (add_list "   - der Krmmungs-Kreis im Klothoidenendpunkt")
  (add_list "   - der Mittelpunkt dieses Kreises")
  (add_list "   - die Tangenten in Start- und Endpunkt")
  (add_list "   - Markierungspunkte im Anfangs- und Endpunkt der Klothoide")
  (add_list "  gezeichnet werden. Unter Zuhilfenahme dieser Zeichnungsobjekte")
  (add_list "  kann die Klothoide mittels geeigneter Objektfangmodi eindeutig")
  (add_list "  \"angefat\" und damit besser manipuliert werden.")
  (add_list "  Layer und Farbe dieser Objekte sind frei whlbar.")
  (add_list "  Die Markierungpunkte werden als PUNKT gezeichnet. Um sie in der")
  (add_list "  Zeichnung sehen zu knnen, mssen ggf. die Systemvariablen")
  (add_list "  PDMODE und PDSIZE den Erfordernissen angepat werden.")
  (add_list " ")
  (add_list " ")
  (add_list " ")
  (add_list "  COPYRIGHT:")
  (add_list "  ----------")
  (add_list "  Vorliegende Programmversion darf beliebig kopiert und weiter-")
  (add_list "  gegeben werden unter folgenden Bedingungen:")
  (add_list "    - das Programm darf inhaltlich nicht verndert werden")
  (add_list "    - es mssen stets alle zum Programm gehrenden Dateien")
  (add_list "      kopiert werden.")
  (add_list "      In der Datei KLOTHO11.ARJ sind enthalten:")
  (add_list " ")
  (add_list "      * KLOTHO11.LSP")
  (add_list "      * KLOTHO11.DCL")
  (add_list "      * KLOTHO11.TXT")
  (add_list " ")
  (add_list " ")
  (add_list "  Registrierte Nutzer (siehe Schaltfeld \"Info\") erhalten eine")
  (add_list "  Vollversion dieses Programmes, in der auch die Funktionen")
  (add_list "  \"Hilfsobjekte\" integriert sind.")
  (add_list "  Sie werden auerdem ber Weiterentwicklungen des Programmes")
  (add_list "  informiert und knnen Updates gnstig erwerben.")
  
  (end_list)
  (start_dialog)
)

(defun *error* (meldg)
  (princ "\nProgramm abgebrochen")
  (princ)
)
  

;---------------
;Hauptprogramm
;---------------
(defun c:klotho ()
  (setq flag0 nil)
  (setq nr (load_dialog "klotho11.dcl"))
  (if (not (new_dialog "klotho" nr))
    (exit)
  )
  (init)
  (action_tile "accept" "(setq flag0 t)(done_dialog)")
  (action_tile "genau" "(genau)")
  (action_tile "obj_hilfe" "(obj_h)")
  (action_tile "_er" "(radius)")
  (action_tile "_ep" "(param)")
  (action_tile "_el" "(laenge)")
  (action_tile "_ew" "(winkel)")
  (action_tile "_exp" "(setq exp_ $value)(set_tile \"_exp\" (rtos (atof exp_)))")
  (action_tile "_eyp" "(setq eyp_ $value)(set_tile \"_eyp\" (rtos (atof eyp_)))")
  (action_tile "_ewp" "(setq ewp_ $value)(set_tile \"_ewp\" (rtos (atof ewp_)))")
  (action_tile "info" "(info)")
  (action_tile "help" "(onl_h)")
  (start_dialog)
  (unload_dialog nr)
  (if (= flag0 t)    
    (progn
      (setq _anz anz_)
      (setq _we we_)
      (setq _glatt glatt_)
      (setq _exp exp_) (setq exp (atof _exp))
      (setq _eyp eyp_) (setq eyp (atof _eyp))
      (setq _ewp ewp_) (setq ewp (atof _ewp))
      (if (/= flag_z nil) (z_klot))
    )
  )
  (princ)
)
